desc "统计实践课程的学习统计数据"
namespace :subjects do
 # File.new("#{Rails.root}/log/rake_error.log", "r+") unless File.exist?("#{Rails.root}/log/rake_error.log")
  file = File.open("#{Rails.root}/log/rake_error.log", File::WRONLY | File::APPEND)
  rake_logger = Logger.new(file)
  task data_statistic: :environment do
    puts("---------------------data_statistic_begin")
    Rails.logger.info("---------------------data_statistic_begin")
    subjects = Subject.where(public: 2, hidden: 0)
    if ENV['subject_id'].present?
      subjects = subjects.where(id:ENV['subject_id'])
    end
    column_value = "subject_id, study_count, course_study_count, initiative_study, passed_count, course_used_count, " +
        "school_used_count, created_at, updated_at"
    subjects.find_in_batches(batch_size: 50) do |s|
      str = []
      Parallel.each_with_index(s, in_threads: 4) do |subject, index|
        puts("---------------------data_statistic: #{subject.id}")
        Rails.logger.info("---------------------data_statistic: #{subject.id}")
        data = Subjects::DataStatisticService.new(subject)
        study_count = data.study_count
        next if study_count == 0
        course_study_count = data.course_study_count
        initiative_study = study_count - course_study_count
        str << ("(#{subject.id}, #{study_count}, #{course_study_count}, #{initiative_study}, " +
            "#{data.passed_count}, #{data.course_used_count}, #{data.school_used_count}, " +
            "'#{Time.now.strftime('%Y-%m-%d %H:%M:%S')}', '#{Time.now.strftime('%Y-%m-%d %H:%M:%S')}')")
        puts "index: #{index}; worker_number: #{Parallel.worker_number}"
        puts "####str: #{str}"
      end
      if str.size > 0
        sql = "REPLACE INTO subject_records(#{column_value}) VALUES #{str.uniq.join(",")}"
        puts sql
        ActiveRecord::Base.connection.execute sql
      end
    end

    puts("---------------------data_statistic_end")
    Rails.logger.info("---------------------data_statistic_end")
  end

  task course_info_statistic: :environment do
    puts("---------------------course_info_statistic_begin")
    Rails.logger.info("---------------------course_info_statistic_begin")
    subjects = Subject.where(public: 2, hidden: 0)
    column_value = "subject_id, school_id, school_name, course_count, student_count, choice_shixun_num, " +
        "choice_shixun_frequency, created_at, updated_at"
    if ENV['subject_id'].present?
      subjects = subjects.where(id:ENV['subject_id'])
    end

    begin
      subjects.find_in_batches(batch_size: 20) do |s|
        Parallel.each_with_index(s, in_processes: 4) do |subject|
          puts("---------------------course_info_statistic: #{subject.id}")
          Rails.logger.info("---------------------course_info_statistic: #{subject.id}")
          data = Subjects::CourseUsedInfoService.call(subject)
          str =[]
          data.each do |key|
            next if key[:school_id].nil?
            str << ("(#{subject.id}, #{key[:school_id]}, '#{key[:school_name].gsub(/'/, '"')}', #{key[:course_count]}, " +
                "#{key[:student_count]}, #{key[:choice_shixun_num]}, #{key[:choice_shixun_frequency]}, " +
                "'#{Time.now.strftime('%Y-%m-%d %H:%M:%S')}', '#{Time.now.strftime('%Y-%m-%d %H:%M:%S')}')")
            # if str.size == 1000
            #   sql = "REPLACE INTO subject_course_records(#{column_value}) VALUES #{str.uniq.join(",")}"
            #   str_c = str
            #   puts sql
            #   ActiveRecord::Base.connection.execute sql
            #   str -= str_c
            # end
          end
          if str.size > 0
            sql = "REPLACE INTO subject_course_records(#{column_value}) VALUES #{str.uniq.join(",")}"
            puts sql
            ActiveRecord::Base.connection.execute sql
          end
        end
      end
    rescue Exception => e
      rake_logger.error("user_info_statistic_error: #{e.message}")
    end
    puts("---------------------course_info_statistic_end")
    Rails.logger.info("---------------------course_info_statistic_end")
  end

  task shixun_info_statistic: :environment do
    puts("---------------------shixun_info_statistic_begin")
    Rails.logger.info("---------------------shixun_info_statistic_begin")
    subjects = Subject.where(public: 2, hidden: 0)
    if ENV['subject_id'].present?
      subjects = subjects.where(id:ENV['subject_id'])
    end
    column_value = "subject_id, shixun_id, stage, shixun_name, challenge_count, course_count, " +
        "school_count, used_count, passed_count, evaluate_count, passed_ave_time, created_at, updated_at"
    begin
      subjects.find_in_batches(batch_size: 20) do |s|
        Parallel.each_with_index(s, in_processes: 4) do |subject|
          puts("---------------------shixun_info_statistic: #{subject.id}")
          Rails.logger.info("---------------------shixun_info_statistic: #{subject.id}")
          data = Subjects::ShixunUsedInfoService.call(subject)
          str = []
          data.each do |key|
            next if key[:shixun_id].nil?
            str << ("(#{subject.id}, #{key[:shixun_id]}, '#{key[:stage]}', '#{key[:name]}', #{key[:challenge_count]}, " +
                "#{key[:course_count]}, #{key[:school_count]}, #{key[:used_count]}, #{key[:passed_count]}, " +
                "#{key[:evaluate_count]}, #{key[:passed_ave_time]}, " +
                "'#{Time.now.strftime('%Y-%m-%d %H:%M:%S')}', '#{Time.now.strftime('%Y-%m-%d %H:%M:%S')}')")
            # if str.size == 1000
            #   sql = "REPLACE INTO subject_shixun_infos(#{column_value}) VALUES #{str.join(",")}"
            #   puts sql
            #   str = []
            #   ActiveRecord::Base.connection.execute sql
            # end
          end
          if str.size > 0
            sql = "REPLACE INTO subject_shixun_infos(#{column_value}) VALUES #{str.join(",")}"
            puts sql
            ActiveRecord::Base.connection.execute sql
          end
        end
      end
    rescue Exception => e
      rake_logger.error("shixun_info_statistic: #{e.message}")
    end
    puts("---------------------shixun_info_statistic_end")
    Rails.logger.info("---------------------shixun_info_statistic_end")
  end

  task user_info_statistic: :environment do
    puts("---------------------user_info_statistic_begin")
    Rails.logger.info("---------------------user_info_statistic_begin")
    subjects = Subject.where(public: 2, hidden: 0)
    if ENV['subject_id'].present?
      subjects = subjects.where(id:ENV['subject_id'])
    end
    column_value = "user_id, subject_id, username, passed_myshixun_count, passed_games_count, " +
        "code_line_count, evaluate_count, cost_time, created_at, updated_at"
    begin
      subjects.find_in_batches(batch_size: 20) do |s|
        Parallel.each_with_index(s, in_processes: 4) do |subject|
          puts("---------------------user_info_statistic: #{subject.id}")
          Rails.logger.info("---------------------user_info_statistic: #{subject.id}")
          data = Subjects::UserUsedInfoService.call(subject)
          str = []
          data.each do |key|
            next if key[:name].blank?
            str << ("(#{key[:user_id]}, #{subject.id}, '#{key[:name].gsub(/'/, '"')}', #{key[:passed_myshixun_count]}, " +
                "#{key[:passed_games_count]}, #{key[:code_line_count]}, #{key[:evaluate_count]}, '#{key[:cost_time]}', " +
                "'#{Time.now.strftime('%Y-%m-%d %H:%M:%S')}', '#{Time.now.strftime('%Y-%m-%d %H:%M:%S')}')")
            # if str.size == 1000
            #   put "str: #{str}"
            #   sql = "REPLACE INTO subject_user_infos(#{column_value}) VALUES #{str.join(",")}"
            #   ActiveRecord::Base.connection.execute sql
            #   str = []
            # end
          end
          if str.size > 0
            sql = "REPLACE INTO subject_user_infos(#{column_value}) VALUES #{str.join(",")}"
            puts sql
            ActiveRecord::Base.connection.execute sql
          end
        end
      end
    rescue Exception => e
      rake_logger.error("user_info_statistic_error: #{e.message}")
    end

    puts("---------------------user_info_statistic_end")
    Rails.logger.info("---------------------user_info_statistic_end")
  end



  end
